#ifndef SCENE_H_
#define SCENE_H_

typedef struct vec3 { float x, y, z; } vec3_t;
typedef struct vec4 { float x, y, z, w; } vec4_t;

struct mesh {
	vec3_t *vert;
	vec4_t *col;
	int num_vert;
};

struct scene {
	struct mesh *obj;
	int num_obj;
};

struct scene *load_scene(const char *fname);
void free_scene(struct scene *scn);
void draw_scene(struct scene *scn);

#endif	/* SCENE_H_ */
