; n-th plane is selected by setting the n-th bit of the map mask register
; (reg 2 of the sequence controller) to 1

%define REG_SEQ		3c4h
%define REG_CRTC	3d4h
%define REG_MISC	3c2h

	section .data
crt_params:
	dw 00d06h	; vertical total
	dw 03e07h	; overflow
	dw 04109h	; cell height (2 to double scan)
	dw 0ea10h	; vsync start
	dw 0ac11h	; vsync end and protect cr0-cr7
	dw 0df12h	; vertical displayed
	dw 00014h	; turn off dword mode
	dw 0e715h	; vblank start
	dw 00616h	; vblank end
	dw 0e317h	; turn on byte mode
crt_param_len	equ $-crt_params

	section .code
global _set_modex
_set_modex:
	; start by entering mode 13h
	mov ax, 13h
	int 10h

	; disable chaining
	mov dx, REG_SEQ
	mov ax, 0604h
	out dx, ax

	; syncronous reset while setting misc
	mov ax, 0100h
	out dx, ax

	; select 25mhz dot clock & 60hz refresh
	mov dx, REG_MISC
	mov al, 0e3h
	out dx, al

	; restart sequencer
	mov dx, REG_SEQ
	mov ax, 0300h
	out dx, ax

	mov dx, REG_CRTC ; reprogram CRTC
	mov al, 11h	; vsync end reg contains
	out dx, al	;   reg write protect bit
	inc dx		; CRTC data register
	in al, dx	; get vsync end register
	and al, 7fh	; remove write protect
	out dx, al
	dec dx		; CRTC index
	cld
	mov si, crt_params
	mov cx, crt_param_len
.paramloop:
	lodsw		; get next CRT index/data pair
	out dx, ax	; set the next CRT index/data pair
	loop .paramloop

	mov dx, REG_SEQ
	mov ax, 0f02h
	out dx, ax	; enable writes to all 4 planes
	mov ax, 0a000h
	mov es, ax
	xor di, di
	xor ax, ax
	mov cx, 8000h
	rep stosw
	ret
