#include <iostream.h>
#include <conio.h>
#include <math.h>
#include <time.h>
#include "video.h"
#include "mouse.c"
#include "precalc.h"

struct PSource {
	double x,y;
	double strength;

	void InitSource(double X, double Y, double str) { x=X;y=Y;strength=str; }
};

inline unsigned long CalculatePixel(int x, int y, PSource *attr, int NumOfAttractors, double EscapeConst);

VGA *video = NULL;
PSource *Attractors;
const int NumAttractors = 3;
const double EscapeConst = 0.00000012;
int x,y,i;
double di=0,dj=0;
long StartTime = 0, numFrames = 0;

int main() {

	InitLUT();

	if(!IfMouse()) return 0;

	Attractors = new PSource[NumAttractors];

	Attractors[0].InitSource(100.0, 100.0, 10.0);
	Attractors[1].InitSource(200.0, 100.0, 10.0);
	Attractors[2].InitSource(10,10,10);


	video = new VGA;

	for(i=0;i<256;i++) {
		video->SetPal(0,0,i/4, i);
	}

	dj=10;
	unsigned long color;

	StartTime = clock();	// get start time in ticks

	while(!kbhit()) {	// main loop

		ReadMouse();
		if(MouseX > 319) MouseX = 319;

		Attractors[0].InitSource(150.0+Sin(di*2)*40, 100.0+Cos(di)*30, 10.0);
		Attractors[1].InitSource(180.0+Cos(dj)*30, 100.0+Sin(dj*2)*30, 10.0);
		Attractors[2].InitSource(MouseX, MouseY, 10);

		memset(video->BackBuffer, 0, 64000);

		for(y=0;y<200;y++) {
			for(x=0;x<320;x++) {
				color = CalculatePixel(x,y, Attractors, NumAttractors, EscapeConst);
				if(color > 255) color = 255;
				if(color > 0 && x<320 && x>=0 && y<200 && y>=0) {
					video->BackBuffer[(y<<8)+(y<<6)+x] = color;
					//video->PutPixel(x,y,color,video->BackBuffer);
				}
			}
		}

		video->PutPixel(MouseX, MouseY, 255, video->BackBuffer);
		video->Flip(1);

		di+=0.2;
		dj+=0.2;

		numFrames++;
	}

	// calculate total running time
	long TotalTime = clock() - StartTime;

	// now get FPS
	TotalTime = TotalTime / CLK_TCK;
	float FPS = (float)(numFrames) / (float)(TotalTime);


	video->FadeOut();

	CleanLUT();
	delete [] Attractors;
	delete video;

	cout << "This little effect is coded by  Nuclear / the Lab\n";
	cout << "average fps: " << FPS << endl;

	return 0;
}




inline unsigned long CalculatePixel(int x, int y, PSource *attr, int NumOfAttractors, double EscapeConst) {

	double X = (double)x;
	double Y = (double)y;
	double dist, dx, dy;
	double potential = 0.0;
	int i;

	for(i=0;i<NumOfAttractors;i++) {
		dx = X - attr[i].x;
		dy = Y - attr[i].y;
		dist = dx*dx + dy*dy;
		if(dist != 0.0) {
			potential += 1/(dist*dist);
		} else {
			potential += EscapeConst;	// potential = lim tou dist->0 = infinate (= division by 0 :)
		}
	}

	if(potential > EscapeConst) {
		if(potential > 4294967295) {
			return 4294967295;
		} else {
			return (unsigned long)(potential * 100000000);
		}
	}
	// else
	return 0;
}
