#ifndef _VIDEO_H_
#define _VIDEO_H_

#define ResX 320
#define ResY 200

#include "typedefs.h"

class VGA {
public:
	byte Pal[256][3];
	byte *VideoMem, *BackBuffer;

	VGA();
	~VGA();
	void Clear(byte c, byte *where);
	inline void PutPixel(int x, int y, byte c, byte *where) {where[(y<<6)+(y<<8)+x] = c;}
	void GetPal(byte &R, byte &G, byte &B, byte index);
	void SetPal(byte R, byte G, byte B, byte index);
	void WaitRetrace();
	void BlackOut();
	void FadeIn();
	void FadeOut();
	void GrabPal();
	void RestorePallette();
	void Flip(int VSync = 1);

	// Graphic Shapes Functions
	void Circle(int x, int y, const int radius, int c, byte *where);
	void Rect(int left, int top, int right, int bottom, byte color, byte *where);
	void Line(int a, int b, int c, int d, int col, byte *where);
	void HLine(int x1, int x2, int y, int col, byte *where);
	void VLine(int x, int y1, int y2, int col, byte *where);

	//Math functions
	int sgn(int a);
	int round(long a);
};
#endif	// _VIDEO_H_
