#include <stdio.h>
#include "bmpfile.h"

int LoadBMP8(char *filename, BYTE *surface) {
	int i, j;
	bitmap bmp;
	memset(&bmp, 0, sizeof(bmp));
	FILE *fp = NULL;
	fp = fopen(filename, "rb");
	if(!fp) {
		ErrorHandler(ER_LOADFILE);
		return -1;
	}

	//read from file
	fread(&bmp.identifier, 2, 1, fp);
	fread(&bmp.filesize, 4, 1, fp);
	fseek(fp, 4, 1); // reserved
	fread(&bmp.dataoffset, 4, 1, fp);
	fread(&bmp.headersize, 4, 1, fp);
	fread(&bmp.width, 4, 1, fp);
	fread(&bmp.height, 4, 1, fp);
	fseek(fp, 8, 1); // useless
	fread(&bmp.datasize, 4, 1, fp);
	fseek(fp, 16, 1); // jumping to palette
	fread(&bmp.palette, 1024, 1, fp);

	// Set the palette
	for(i=0;i<256;i++) {
		video->SetPal(bmp.palette[4*i+2]>>2, bmp.palette[4*i+1]>>2, bmp.palette[4*i]>>2, i);
	}

	memset(surface, 0, bmp.height * bmp.width);

	// read the actual data
	fseek(fp, bmp.dataoffset-bmp.width, 0);
	for(i=bmp.height;i>=0;i--) {
		fread(&bmp.data, bmp.width, 1, fp);
		for(j=0;j<bmp.width;j++) {
			surface[i*bmp.width+j] = bmp.data[j];
		}
	}

	fclose(fp);
	return 0;
}



int LoadFont(char *filename, BYTE *fontsurf) {
	int i, j;
	bitmap bmp;
	memset(&bmp, 0, sizeof(bmp));
	FILE *fp = NULL;
	fp = fopen(filename, "rb");
	if(!fp) {
		ErrorHandler(ER_LOADFILE);
		return -1;
	}

	//read from file
	fread(&bmp.identifier, 2, 1, fp);
	fseek(fp, 0x000A, 0);
	fread(&bmp.dataoffset, 4, 1, fp);
	fseek(fp, 0x0012, 0);
	fread(&bmp.width, 4, 1, fp);
	fread(&bmp.height, 4, 1, fp);
	fseek(fp, 0x0022, 0);
	fread(&bmp.datasize, 4, 1, fp);

	memset(fontsurf, 0, bmp.height * bmp.width);

	// read the actual data
	fseek(fp, bmp.dataoffset, 0);
	for(i=bmp.height;i>0;i--) {
		fread(&bmp.data, bmp.width, 1, fp);
		for(j=0;j<bmp.width;j++) {
			memset(fontsurf+(i*bmp.width+j), bmp.data[j], 1);
		}
	}

	fclose(fp);
	return 0;
}
