#ifndef _VIDEO_H_
#define _VIDEO_H_

#include "typedefs.h"

typedef unsigned char 	bool;
#define true	1
#define false	0

extern byte *VideoMem;
extern byte *BackBuffer;

void SetVideoMode(void);
void SetTextMode(void);

void Clear(byte color, byte *where);
void PutPixel(int x, int y, byte color, byte *where);
void GetPal(byte index, byte *R, byte *G, byte *B);
void SetPal(byte index, byte R, byte G, byte B);
void WaitRetrace(void);
void Flip(bool VSync);

// Graphic Shapes Functions
void Circle(int x, int y, int radius, int color, byte *where);
void Rect(int left, int top, int right, int bottom, byte color, byte *where);
void Line(int a, int b, int c, int d, int color, byte *where);
void HLine(int x1, int x2, int y, int color, byte *where);
void VLine(int x, int y1, int y2, int color, byte *where);

//Math functions
int sgn(int a);
int round(long a);

#endif	// _VIDEO_H_
