#include <stdio.h>
#include <stdlib.h>
#include "gfx.h"

int main(int argc, char **argv)
{
	unsigned short *fb, red, blue;
	unsigned int i, j, xsz = 640, ysz = 480, bpp = 16;
	int rbits, gbits, bbits, rshift, gshift, bshift;

	if(argc > 2) {
		xsz = atoi(argv[1]);
		ysz = atoi(argv[2]);
	}

	if(!(fb = set_video_mode(xsz, ysz, bpp))) {
		return 1;
	}
	bpp = get_color_depth();
	printf("got bpp: %d\n", bpp);

	/*set_palette(0, 255, 0, 0);
	set_palette(1, 0, 0, 255);*/

	get_color_bits(&rbits, &gbits, &bbits);
	get_color_shift(&rshift, &gshift, &bshift);

	red = (0xff >> (8 - rbits)) << rshift;
	blue = (0xff >> (8 - bbits)) << bshift;

	for(j=0; j<ysz; j++) {
		for(i=0; i<xsz; i++) {
			fb[j * xsz + i] = ((i >> 4) & 1) == ((j >> 4) & 1) ? red : blue;
		}
	}

	getch();
	set_text_mode();
	return 0;
}
